import numpy as np
import pandas as pd


# Toma de datos de planilla Excel
df = pd.read_excel (r'C:\Users\Zeta\Documents\Programacion\Investigacion Operativa\IO Guia 3.1 Tabla_excel_datos.xlsx') #place "r" before the path string to address special character, such as '\'. Don't forget to put the file name at the end of the path + '.xlsx'
# lee los datos de una tabla de excel y los almacena como un dataframe
# print (df)

matriz = df.to_numpy()
# convierte el dataframe a un array (no toma la primera fila con los nombres de las columnas)

Columnas = df.columns.values
# almacena los nombres de las columnas del excel en la lista "Columnas"

print (Columnas)

print (matriz)
# cada linea de la matriz representa una restriccion
# la ultima linea contiene al funcional
# la anteultima columna indica "igual" / ">" / "<" para cada restriccion
# la ultima columna contiene el valor RHS para cada restriccion
# la primera columna tiene el nombre de la restriccion


cant_variables = len(matriz[0])-4
print(f"La cantidad de variables ingresada es: {cant_variables}")
cant_restricciones = len(matriz)-1
print(f"La cantidad de restricciones ingresadas es: {cant_restricciones}")


lista_variables = list(Columnas[1:cant_variables+1])
# no toma el primer elemento (encabezado de restricciones)
print(lista_variables)

# Resolviendo con PuLP
from pulp import*
#ejs: LpMaximize, LpProblem, LpStatus, lpSum, LpVariable, LpMinimize, value

# Creacion del Modelo
model = LpProblem(name="IO_Ej_Guia_3.1", sense=LpMaximize)

# Inicializacion de Variables de decision
X = {i: LpVariable(name=f"{lista_variables[i]}", lowBound=0) for i in range(0, cant_variables)}
# Crea un diccionario de variables X con keys 0,1,2....[cant_variables-1]

# Introduciendo las restricciones al modelo
for a in range(0,cant_restricciones):
    if matriz[a, len(matriz[0])-2] == "igual":
     model += lpSum(X[b] * matriz[a, b+1] for b in range(0,cant_variables)) == matriz[a, len(matriz[0])-1], f"{matriz[a,0]}"
    elif matriz[a, len(matriz[0])-2] == ">=":
        model += lpSum(X[b] * matriz[a, b+1] for b in range(0, cant_variables)) >= matriz[
            a , len(matriz[0]) - 1], f"{matriz[a,0]}"
    elif matriz[a, len(matriz[0]) - 2] == "<=":
        model += lpSum(X[b] * matriz[a, b+1 ] for b in range(0, cant_variables)) <= matriz[
            a, len(matriz[0]) - 1], f"{matriz[a,0]}"

# Introduciendo la funcion objetivo
model += lpSum(matriz[len(matriz)-1, c+1] * X[c] for c in range(0,cant_variables)) + matriz[len(matriz)-1,len(matriz[0])-3]

print(model)

# Llamado a la solucion del problema
status = model.solve()

print(model)

# Impresion de resultados
print(f"status: {model.status}, {LpStatus[model.status]}")
print("Valor Optimo del Funcional:")
print(f"objective: {model.objective.value()}")

for var in model.variables():
    print(f"{var.name}: {var.value()}")

for name, constraint in model.constraints.items():
    print(f"{name}: {constraint.value()}")
    if constraint.value() <= 0:
        print("(representa un sobrante del recurso no utilizado)")
    elif constraint.value() >= 0:
        print("(representa un excedente sobre la restriccion de minimo planteado)")
